#include "Stack.h"
#include "ArrayImplementor.h"
#include "ListImplementor.h"

Stack :: Stack(ImplementationType type)
{
	switch (type)
	{
		case ARRAY: 
			stackData = (StackImplementor*) new ArrayImplementor(); break;
		case LIST: 
			stackData = (StackImplementor*) new ListImplementor(); break;
		default: 
			stackData = (StackImplementor*) new ArrayImplementor();
	}
}

Stack :: ~Stack()
{
	delete stackData;
}

void Stack :: push( int val )
{
	stackData->push( val );
}


int Stack :: pop()
{
	return stackData->pop();
}


bool Stack :: isEmpty()
{
	return stackData->isEmpty();
}


bool  Stack :: isFull()
{
	return stackData->isFull();
}
