// BRIDGE DESIGN PATTERN
// 
// Our Stack class needs to allow the client to specify 
// what implementation strategy to employ (i.e. list vs array).


#include <iostream>
#include "Stack.h"
#include "LIFO_Stack.h"
#include "HanoiStack.h"

using namespace std;

int main () 
{
	/* When experimenting see if you can use
	a LIFO_Stack implemeted as an ARRAY or 
	an HanoiStack implemented as LIST
	*/
	Stack* stack1 = new HanoiStack( ARRAY );
	Stack* stack2 =new LIFO_Stack( LIST );
	
	for (int i=1; i < 10; i++)
	{
		int value;
		cout <<	i << ":";
		cin >> value;
		stack1->push( value );
		stack2->push( value );
        }

   cout << "stack1 (Currently Hanoi-ARRAY):\n";
   for (int i=1; i < 10 ; i++)
   {
      cout << stack1->pop() << " ";
   }
   cout << endl;

   cout << "stack2 (Currently LIFO-LIST):\n";
   for (int i=1; i < 10 ; i++)
   {
	   cout << stack2->pop() << "  ";
   }
   cout << endl;
   delete stack1;
   delete stack2;
   return 0;
}

